/*
 *********************************************************************
 * Created on ${date}
 *
 * Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
 *
 * This file may be distributed and used only under the terms of the  
 * Terabit Public License as defined by Terabit Pty Ltd of Australia   
 * and appearing in the file tlicense.txt included in the packaging of
 * this module and available at http://www.terabit.com.au/license.php.
 *
 * Contact support@terabit.com.au for any information
 *********************************************************************
 */

package au.com.terabit.jproactor;

//import java.io.IOException;
//import java.net.InetAddress;
//import java.net.InetSocketAddress;
import java.net.SocketAddress;
//import java.net.UnknownHostException;
import java.nio.channels.SocketChannel;

/**
 
 *
 * @author Alexander Libman
 * @author Yevgeny Libman
 * @version <code>$Revision$ $Date$</code>
 */
public class Connector implements AsynchConnectHandler 
{
    /**
     * Procotol factory assigned for this socket address 
     */
    AsynchChannelHandlerFactory m_factory = null;

    /**
     * Demultiplexor instance 
     */
    Demultiplexor m_multiplexor = null;
    
    

    // ------------------------------------------------------------------------
    // Public methods

 
    /**
     */
    public Connector(Demultiplexor m, 
                     AsynchChannelHandlerFactory factory)
    {
        this.m_factory = factory;
        this.m_multiplexor = m;
        
    }

    
    //
    // Interface AsynchConnectHandler implementation
    //
    
 
    /**
     * Implementation of {@link AsynchChannelHandler#acceptCompleted(OpAccept op)}.
     * Executes accept operation, non-blocking, instantiates protocol on the
     * accepted channel, starts protocol using acceptor's multiplexor instance.
     * 
     * @throws Exception if this method is called
     */
    public void connectCompleted( OpConnect op ) throws Exception
    {
        AsynchChannel asynchChannel = op.getChannel();
        
        if ( op.getError() != null )
        {    
            System.out.println( op.getError().toString());
            asynchChannel.close();
            return;
          
        }
        // now handle new connection
        AsynchChannelHandler protocol = m_factory.createChannelHandler ();

        asynchChannel.setChannelHandler (protocol);
    }

 
    /**
     * 
     */
    public void start(SocketAddress address ) throws Exception
    {
        TCPAsynchChannel achannel = new TCPAsynchChannel (m_multiplexor, SocketChannel.open());
        achannel.connect (address, this);
    }
    
}